

import java.util.ArrayList;
import java.util.List;
import javafx.event.ActionEvent;
import javafx.scene.text.Font;
import okay.datetime.UniversalDateTime;
import okay.pseudorandom.PseudoRandomGenerator;
import okay.simplicity.EnumColour;
import okay.simplicity.Simplicity;
import okay.simplicity.window.CellLayout;
import okay.simplicity.window.WindowColourSkin;
import okay.simplicity.window.controls.Button;
import okay.simplicity.window.controls.SLabel;
import okay.simplicity.window.controls.TextField;

/**
 *
 * @author root
 */
public class PasswordGenerator {

    private static class ExtraWindow extends okay.simplicity.window.Window {

        private final static List chars;
        private final static int CHARSSIZE;
        private final static String SPACE=" ";

        private PseudoRandomGenerator[] pseudoRandomGenerator;
        private PseudoRandomGenerator prg;

        private TextField newPasswordTextField;
        private Button generateNewPasswordButton;

        static {
            chars = new ArrayList<Character>();
            for (int i = 49; i <= 57; i++) {
                chars.add(new Character((char) (i)));
            }
            for (int i = 65; i <= 90; i++) {
                if(i==79)continue;
                chars.add(new Character((char) (i)));
            }
            for (int i = 97; i <= 122; i++) {
                if(i==111)continue;
                chars.add(new Character((char) (i)));
            }
            CHARSSIZE = chars.size();
        }

        public ExtraWindow() {

        }

        private String getNewPassword() {
            StringBuilder stringBuilder = new StringBuilder();
            for (int i = 1; i <= 8; i++) {
                stringBuilder.append(this.getRandomChar());
            }
            return stringBuilder.toString();
        }

        private char getRandomChar() {
            int i = prg.getInt(0, 31);
            PseudoRandomGenerator prg10=pseudoRandomGenerator[i];
            
            int ii = prg10.getInt(0, CHARSSIZE - 1);
            
            return (char)chars.get(ii);
        }

        private void handleGenerateNewPasswordButtonAction(ActionEvent event) {
            this.setNewPasswordToTheNewPasswordTextField();
        }

        private void setNewPasswordToTheNewPasswordTextField() {
            this.newPasswordTextField.setText(this.getNewPassword()+SPACE+this.getNewPassword());
        }

        @Override
        protected void initAreaForUserInteraction() {
            this.setWindowTitle("Password generator");
            this.showOnlyTheCloseButton();
            this.setHeight(400);

            prg = new PseudoRandomGenerator(PseudoRandomGenerator.getInstance().getInt(0, 999999999), UniversalDateTime.getCurrentUniversalDateTime());
            pseudoRandomGenerator = new PseudoRandomGenerator[32];
            for (int i = 0; i <= 31; i++) {
                UniversalDateTime universalDateTime = UniversalDateTime.getRandomUniversalDateTime();
                pseudoRandomGenerator[i] = new PseudoRandomGenerator(prg.getInt(0, 999999999), universalDateTime);
            }
            CellLayout cellLayout = new CellLayout(2, 2, "50% 50%");
            this.applicationArea.getChildren().add(cellLayout);
            SLabel newPasswordLabel = new SLabel("New password");
            newPasswordTextField = new TextField();
            newPasswordTextField.setFont(new Font("Courier New",24));
            
            cellLayout.addNodes(1, newPasswordLabel, newPasswordTextField);
            generateNewPasswordButton = new Button("Generate new password");

            cellLayout.addNode(generateNewPasswordButton, 1, 2, 2, 1);

            this.generateNewPasswordButton.setOnAction(this::handleGenerateNewPasswordButtonAction);

            this.setNewPasswordToTheNewPasswordTextField();
        }
    }

    /**
     * @param args the command line arguments
     */
    private static class Runner implements okay.simplicity.SimplicityRunnerI {

        @Override
        public void run() {
            new ExtraWindow().show();

        }
    }

    public static void main(String[] args) {
        Simplicity.startSimplicity(new Runner(), new WindowColourSkin(EnumColour.getRandom()));

    }
}
